"""file: ex1.py -- Correction TD4 exercise 1

Implements selection sort.

"""

import random

"""find_max(li,d,f) returns the index of the first occurence of the maximum
value appearing in the list 'li[d:f+1]'

li[d] is supposed to exist

"""
def find_max(li,d,f):
  im,m = d,li[d]
  for i in range(d,f+1):
    if li[i]>m: im,m = i,li[i]
  return im

"""select_sort_naive(li) returns a sorted version of 'li' following
the selection sort method.

It is called naive because python's way to concatenate list might
screw up the complexity.

"""
def select_sort_naive(li):
  if li == []: return li;
  imax = find_max(li,0,len(li)-1)
  return selectsort(li[:imax]+li[imax+1:]) + [li[imax]]
  
def selectsort(li):
  # auxialiary function for recursive call -- kind of a loop
  def aux(end, li):
    if end == 1: return None; # nothing to sort left
    imax = find_max(li,0,end-1) #find max until end-1
    li[end-1], li[imax] = li[imax], li[end-1] # swap it with the current final position
    aux(end-1,li) # redo on the sublist without this last position
  tmp = li[:] # copy li to keep it unchanged
  aux(len(tmp),tmp) # act on tmp instead of li
  return tmp

n = 20
example = [random.randrange(1,100) for i in range(n)]
print example
print selectsort(example)
